$APPTYPE GUI : $TYPECHECK ON : $SYMBOLTABLE ON
'this program reads an Intuit Interchange Format (.IIF) file
'(a specifc type of tab-delimited text file; see the Intuit website
'and QuickBooks help for more information on .IIF files)
'it displays client names in a combobox list for user selection
'upon name selection, the client record is located in the .IIF file
'and certain information from that record is displayed
'.IIF files can be exported from Intuit's Quickbooks software
'(be sure Customers are selected when exporting from Quickbooks)
'or created with spreadsheet programs like Excel
'sample IIF files can also be found on the the Intuit website
'this would be a way to access a client list without needing Quickbooks
'access is read-only though routines to modify and save data could be 
'written
DECLARE SUB ChooseFile
DECLARE SUB ClickCheck
DECLARE SUB Done
DECLARE SUB FetchClientList    'look, ma! no hands'
DECLARE SUB FetchClientRecord  'no parameter passing anywhere to be seen'
DECLARE SUB ToggleInactive

APPLICATION.OnExit  = Done     'force an orderly shutdown'

CREATE formfont AS FONT        'hope everyone has this font'
     Name = "Tahoma"           'seems more legible than the default'
     Height = 14
END CREATE

CREATE iifform AS FORM
     Background = 12
     Caption = ".IIF File Reader"
     Height = 340
     Width = 400
     Font = formfont
     Center
     CREATE selector AS COMBOBOX        'select client'
         Top = 30
         Left = 10
         Width = 220
         Height = 20
         OnClick = ClickCheck
     END CREATE
     CREATE info AS RICHEDIT
         Height = 200
         Width = 220
         Left = 10                      'displays extracted info'
         Top = 60
     END CREATE
     CREATE showall AS CHECKBOX         'toggle display of inactive clients'
         Top = 30
         Left = 250
         Font = formfont                'change the font for checkbox label'
         Width = 120
         Height = 20
         Caption = "Show Inactive"
         OnMouseUp = ToggleInactive
         Background = 12
     END CREATE
     CREATE cancelbutton AS BUTTON
         Caption = "Exit"
         OnClick = Done
         Height = 20
         Width = 50
         Font = formfont                'change the font for button label'
         Left = 320
         Top = 60
     END CREATE
     CREATE choosebutton AS BUTTON      'button button who's got the button'
         Top = 60
         Left = 250
         Font = formfont                'change the font for button label'
         Width = 50
         Height = 20
         Caption = "Open"
         OnClick = ChooseFile
     END CREATE
     CREATE filechooser AS OPENDIALOG
         DefExt = "iif"
         Caption = "Select .IIF file"
         InitialDir = "."
     END CREATE
END CREATE
CREATE filemenu AS MAINMENU            'not very sexy but what the heck'
     Caption = "&File"
     CREATE openitem AS MENUITEM
         Caption = "&Open"
         OnClick = ChooseFile
         Separator
     END CREATE
     CREATE exititem AS MENUITEM
         Caption = "E&xit"
         OnClick = Done
     END CREATE
END CREATE
                                       'love those file streams
DIM iiffile AS FILE                    'need one of these'
                                       'man these list things are powerful betcha the Intuit byteheads use 'em'
DIM client   AS LIST                   'holds parsed client record'
DIM found    AS LIST                   'temporarily holds stuff from client record'
DIM inactive AS LIST                   'list of inactive client  - we always display active ones'
DIM header   AS LIST                   'client record header name list'
                                       'and now, the ever amazing BASIC STRING'
DIM buffer  AS STRING                  'file read buffer'
DIM find    AS STRING                  'holds the name of client to fetch from file'
DIM iifname AS STRING                  'holds the file name'
                                       'I'm such a creature of habit - 4 bytes each ain't much these days
DIM addy      AS INTEGER               'field pointer'
DIM phones    AS INTEGER               'field pointer'
DIM x         AS INTEGER               'good old x - our shared gp counter'
DIM beginning AS INTEGER               'file address of beginning of client records'

'--------------------------------------'gotta love it - 3 line program starts here'
filemenu.Parent = iifform              'well, 4 if ya count END'
iifform.Show                           'the rest is just a buncha lazy subroutines'
choosebutton.Focus
END                                    'dat's da name a dat tune'

'--------------------------------------'user wants to open a file'
SUB ChooseFile
                                       'oof win32.hlp is obscure'
     filechooser.Flags = &H205801      'read-only; maybe redundant since we're opening as RO'
     filechooser.Filter = "Intuit Interchange Format (*.IIF)" + CHR$(0) + "*.IIF" + CHR$(0) + CHR$(0)
     IF filechooser.Execute THEN
        iifname = filechooser.FileName
        FetchClientList
     ELSE
        choosebutton.Focus
     END IF

END SUB
'--------------------------------------'user clicked on the combobox'
SUB ClickCheck                         'process user mouse clicks'

SELECT CASE nCode                      'thanks, Jim, now i get it'
        CASE ONE, 2, 9                 'these 3 indicate a change to selected client'
             FetchClientRecord         'so go get the new information'
        CASE ELSE
             EXIT SUB                  'hard to do if the thing's submerged'
END SELECT

END SUB
'--------------------------------------'unlike retired russian subs, this one extracts a list of names
SUB FetchClientList                    'this doesn't need to be a sub but what the heck'
                                       'Intuit Interchange Format files'
info.Clear : selector.Clear : inactive.Clear   'can be created using Excel "Save as" tab-delimited text
client.Clear : buffer.Clear                    'which defaults to .TXT, so force name by enclosing in'
iiffile.Open iifname, ZERO                     'double quotes, else ya get "file.iif.txt" duh'
WHILE NOT iiffile.EOF                  'you have to know what the Intuit headers look like, tho'
    buffer = iiffile.ReadLine          'get a record'
    buffer = RTRIM$ REPLACESUBSTR$ buffer, CHR$ 34, NULL    'nuke double quotes in multi-word fields and any trailing spaces'
    client.Parse buffer, CHR$ 9                             'parse into one of those cool lists'
    IF client.Item ZERO = "!CUST" THEN                      'marks the client record header a-la Quickbooks Pro'
       header = client                                      'put the header in another list - how easy'
       beginning = iiffile.Position                         'client records start here in the file'
    ELSEIF client.Item ZERO = "CUST" THEN                   'okay, found a client record'
        IF client.Item header.IndexOf "HIDDEN" = "N" THEN   'if not hidden, then must be active'
           selector.AddItems client.Item ONE                'just a bit of inverted logic, but that's programmers for ya'
        ELSE                                                'this one's hidden, so must be inactive'
           inactive.AddItems client.Item ONE                'add it to inactive list, and combobox if checkbox checked'
           IF showall.Checked THEN selector.AddItems client.Item ONE
        END IF
    END IF
    client.Clear                        'tidy up'
    buffer.Clear                        'couldn't hurt'
END WHILE                               'okay, we're done poking around'

buffer.Clear                            'a bit more trash removal'
client.Clear                            'since other subs use these variables'
iiffile.Close                           'close that door, it's cold out there!'

addy   = header.IndexOf "BADDR1"        'index to start of stuff we want to display from each record'
phones = header.IndexOf "PHONE1"        'the capitalized names are from client list header'
selector.Focus                          'we'll choose a client next'

END SUB                                 'okay, so now is it warm out there?'

'---------------------------------------'get info about the selected client'
SUB FetchClientRecord

info.Clear : found.Clear : client.Clear : find.Clear  'redundant perhaps but just in case'
find = RTRIM$ selector.Text  : IF find = "" THEN EXIT SUB  'nothing was selected so leave'
iiffile.Open iifname, ZERO                                 'there's that IIF file again'
iiffile.Seek beginning                                     'go to beginning of client list portion of file
WHILE NOT iiffile.EOF                                      'are we there yet?'
    buffer = iiffile.ReadLine                              'we're doing this again - make a SUB out of it?'
    buffer = RTRIM$ REPLACESUBSTR$ buffer, CHR$ 34, NULL   'and again'
    client.Parse buffer, CHR$ 9                            'this could be in the sub club too'
    IF client.Item ZERO = "CUST" THEN                      'okay found a client record'
       IF client.Item ONE = find THEN                      'is it the ONE????'
          FOR x = addy TO addy + 4                         'yep, so get the 5 billing address fields'
              found.AddItems client.Item x                 'and stick 'em in a list'
          NEXT x                                           'lists are bad in boats but wonderful here in HOT land'
          FOR x = phones TO phones + 2                     'now extract the phone number fields'
              found.AddItems client.Item x                 'and add 'em to the list of things we found'
          NEXT x
          found.AddItems client.Item header.IndexOf "EMAIL" 'there's always all this stuff'
          EXIT WHILE                 'hanging out down here at the end of all these'
       END IF                        'IFs and DOs and whathaveya'
    END IF                           'hmmm, probably gotta trap not found condition'
    client.Clear                     'tho I don't know how that could happen'
    buffer.Clear                     'empty those strings and lists'
END WHILE                            'are we there yet?'
info.Text = found                    'oh yeah, this is what we came here for'
buffer.Clear
found.Clear                          'mustn't be messy'
iiffile.Close                        'all done'
selector.Focus                       'this is nice'

END SUB                              'whew'

'------------------------------------'adds or removes inactive client  from combobox list'
SUB ToggleInactive                   'good thing for modern document editors'
                                     'and the "Replace" command'
IF inactive.ItemCount = ZERO THEN    'in case there aren't any inactives, let's not waste time'
    showall.Checked = FALSE          'clear the checkbox'
    EXIT SUB                         'and leave'
END IF
find = RTRIM$ selector.Text          'store what's displayed in the combobox'

IF showall.Checked THEN              'depends on status of checkbox'
    FOR x = ZERO TO inactive.ItemCount - ONE  'we always know how many of what in any list object'
        selector.AddItems inactive.Item x
    NEXT x                                    'that was simple'
ELSE                                          'or maybe we're removing inactives from combobox list'
    FOR x = ZERO TO inactive.ItemCount - ONE  'we always know how many of what in any list object'
        IF find = inactive.Item x  THEN info.Clear  'clear info display if last selected was inactive client'
        selector.DelItems selector.IndexOf inactive.Item x  'how elegant'
    NEXT x                                                  'and it does this REALLY fast'
END IF                               'magically, the combobox list changed'
find.Clear                           'right before yer eyes'
END SUB                              'dat's all, folks!'

'------------------------------------'user clicked Exit button or frame close button or alt-f4'
SUB Done
                                     'guess they wanna leave or something'
    APPLICATION.Terminate            'okay, if you insist'

END SUB
